Error parsing svn output: #<REXML::ParseException: No close tag for /lists/list>

2010-09-06 16:35 - Ве Fio

Status: Closed Start date: 2010-09-06

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 1.0.1

Description

Redmine: 1.0.1

Ruby: 1.8.7

Subversion: 1.6.6

Using: Apache + Phusion

This only happens while using private projects for me. I used 

Repositories_access_control_with_apache_mod_dav_svn_and_mod_perl, and where it says

     #read-only access    

     <Limit GET PROPFIND OPTIONS REPORT>

        Require valid-user

        Allow from redmine.server.ip

        # Allow from another-ip

         Satisfy any

     </Limit>

I had to comment out "Allow from redmine.server.ip" because it causes private projects to not work correctly (you can checkout, list

private projects without logging in, but you can't commit), where removing it completely fixed it (normal behavior).    

While I had "Allow from..." in there, browsing and seeing the repository worked, but however when I removed it, I get the error "Error

parsing svn output: #<REXML::ParseException: No close tag for /lists/list>" in my production log, and the repository says "The entry

or revision was not found in the repository.", however, I need my private projects to work AND being able to browse them, so this is

quite conflicting...

History

#1 - 2010-09-06 16:36 - Ве Fio

This is related to #3929

#2 - 2010-09-08 04:52 - Ве Fio

Where it says "but you can't commit", that is not valid or true, committing works fine (being able to list and checkout as an anonymous user on private

projects is STILL valid). It was my fault, and I forgot about it and reported that above.

Everything else stated is still 100% valid however.

#3 - 2010-09-08 11:12 - Joonas Pulakka

I found that that parse exception can be caused by permission issues. See #6327.

#4 - 2010-09-10 04:35 - Ве Fio

Unfortunately that wasn't what my problem was (just tried it). I guess it would figure it's not because regular repository browsing works, as long as it's

not a private project.

#5 - 2010-09-10 04:52 - Ве Fio

I found out something about why it was failing. I went to SSH, logged in as the user Redmine runs under, and this is what happened.

<?xml version="1.0"?>

<lists>
https://www.redmine.org/projects/redmine/wiki/Repositories_access_control_with_apache_mod_dav_svn_and_mod_perl
https://www.redmine.org/issues/3929
https://www.redmine.org/issues/6327


<list

   path="http://sub.domain.com/asdf">

Authentication realm: <http://sub.domain.com:80> Site SVN Repository

Password for 'user':

That definitely explains it. I logged in as the correct user, and let it save the password, and the repository browsing worked. However that's a problem,

as I shouldn't have to do that just to make it work! I'm going to do a little more testing...

#6 - 2010-09-10 07:56 - Ве Fio

I realized that the Allow from should work under it's own, when your server has an external IP, however because it's behind a router, the IP that it's

allowing is ALWAYS everyone's IP (192.168.1.1), which makes reads allowed, which under ordinary circumstances would only allow reads from

Redmine only. There's gotta be a way to fix this...

#7 - 2010-09-10 08:38 - Felix Schäfer

Ве Fio wrote:

I realized that the Allow from should work under it's own, when your server has an external IP, however because it's behind a router, the IP that

it's allowing is ALWAYS everyone's IP (192.168.1.1), which makes reads allowed, which under ordinary circumstances would only allow reads

from Redmine only. There's gotta be a way to fix this...

 Many ways:

get more IPs and don't rely on NAT,

add a htpasswd2 file and corresponding configuration with a password for redmine, and put those credentials in the repository configuration of

the affected project(s),

make sure apache listens on localhost, allow auth-less access from localhost and access the repos through localhost instead of your external

hostname,

use file:// access method instead of http://, as redmine and the repos seem to reside on the same host,

use svn+ssh:// instead of http:// and setup a passwordless key authentication for ssh,

and so on...

#8 - 2010-09-10 09:34 - Ве Fio

- Status changed from New to Resolved

file:// works nicely. Thanks. (:

#9 - 2010-09-10 09:54 - Felix Schäfer

- Status changed from Resolved to Closed
